import { ComponentConstructorInfo, ComponentDrawInfo, Coordinate } from '../types';
import Component from '../common/Component';
import { SN } from '../common/definitions';
/**
 * @property {number} length - the axis length.
 * @property {number} width - the width of axis.
 * @property {Coordinate} start - where coordinate to start axis.
 * @property {number} start.x - the axis will align this point rather than start.
 * */
interface DrawInfo extends ComponentDrawInfo {
    length: number;
    width: number;
    start: Coordinate;
}
/**
 * The body of Axis.
 * Draw the axis using this component.
 * */
export default abstract class AxisBody extends Component {
    constructor(props: ComponentConstructorInfo);
    name: SN;
    drawInfo: DrawInfo;
    createBox(): void;
    apply(): Promise<import("../common/Component").MUST_CALL_AND_RETURN_SUPER_METHOD>;
    static is(comp: Component): comp is AxisBody;
}
export {};
