import { ComponentConstructorInfo, ComponentDrawInfo } from '../types';
import Component from '../common/Component';
import { SN } from '../common/definitions';
import AxisBody from '../Axis/AxisBody';
/**
 * @property {Readonly<AxisBodyDrawInfo>} bodyDrawInfo - the DrawInfo of AxisBody.
 * @property {number} alignY - the y point which is the AxisScale align target.
 * @property {number} height - the height of AxisScale.
 * */
interface DrawInfo extends ComponentDrawInfo {
    bodyDrawInfo: Readonly<AxisBody['drawInfo']>;
    alignY: number;
    height: number;
}
/**
 * In axis, mark a mark for recognize time easy.
 * Optional, a theme can omit this component by situation.
 * */
export default abstract class AxisScale extends Component {
    constructor(props: ComponentConstructorInfo);
    name: SN;
    drawInfo: DrawInfo;
    createBox(): void;
    apply(): Promise<import("../common/Component").MUST_CALL_AND_RETURN_SUPER_METHOD>;
    static is(comp: Component): comp is AxisScale;
}
export {};
