"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var functions_1 = require("../common/functions");
var Component_1 = __importDefault(require("../common/Component"));
var definitions_1 = require("../common/definitions");
/**
 * Recognize a event time of duration and end time point.
 * Some Event have no duration, so it needn't EventAxis.
 * Can conflict with AxisMilestone and EventAxis.
 * */
var EventAxis = /** @class */ (function (_super) {
    __extends(EventAxis, _super);
    function EventAxis(props) {
        var _this = _super.call(this, props) || this;
        _this.name = definitions_1.SN.EventAxis;
        _this.drawInfo = {
            axisBodyDrawInfo: {},
            markDrawInfo: {},
            length: 0,
            offsetX: 0,
            box: {
                x: 0,
                y: 0,
                width: 0,
                height: 0,
            },
        };
        _this.ext.onConstruct(_this);
        return _this;
    }
    EventAxis.prototype.createElement = function () {
        var flag = _super.prototype.createElement.call(this); // Must return this flag
        var target = this.drawInfo.markDrawInfo.target;
        this.element.classList.add('sn-endText');
        this.element.innerHTML = this.drawInfo.text;
        var box = functions_1.parseBox(this.element);
        this.element.style.left = target.x + this.drawInfo.offsetX + "px";
        this.element.style.top = target.y - this.drawInfo.length - box.height / 2 + "px";
        return flag;
    };
    EventAxis.prototype.createBox = function () {
        var target = this.drawInfo.markDrawInfo.target;
        this.drawInfo.box = {
            x: target.x,
            y: target.y - this.drawInfo.length,
            width: this.drawInfo.offsetX,
            height: this.drawInfo.length,
        };
    };
    EventAxis.prototype.apply = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (this.drawInfo.text) {
                    this.createElement();
                    this.element.style.visibility = 'hidden';
                }
                else if (this.element) {
                    this.element.parentNode.removeChild(this.element);
                    delete this.element;
                }
                this.createBox();
                return [2 /*return*/, _super.prototype.apply.call(this)];
            });
        });
    };
    EventAxis.prototype.draw = function () {
        if (this.drawInfo.text)
            this.createElement();
        return _super.prototype.draw.call(this);
    };
    EventAxis.is = function (comp) {
        return comp.name === definitions_1.SN.EventAxis;
    };
    return EventAxis;
}(Component_1.default));
exports.default = EventAxis;
