import { DateBy } from '../types';
/**
 * Split a date scope to node by node.
 * @example
 * new TimeSpliter('2017-01-01 00:00:01', '2019-01-01 00:00:01').split(DateBy.Year)
 * > [ '2018-1-1 00:00:00', '2019-1-1 00:00:00' ]
 * */
export default class TimeSpliter {
    constructor(start: number | string | Date, end: number | string | Date);
    bigger: Date;
    smaller: Date;
    /**
     * Return a array of split Date object.
     * */
    split(by: DateBy, step?: number): Date[];
    static increment: {
        [methName in DateBy]: (date: Date, step?: number) => Date;
    };
}
