import { Box, Line, ConflictFixResult } from '../types';
import Timeline from '../Timeline';
export declare function isBox(obj: any): obj is Box;
export declare function box2Lines(box: Box): Line[];
export declare function parseBox(elt: HTMLElement): Box;
export declare function mergeBox(...args: Box[]): Box;
export declare function shrinkBox(box: Box, distance?: number): Box;
export declare function isIntersecting(line1: Line, line2: Line): boolean;
export declare function isOverlap(item1: Box | Line, item2: Box | Line): boolean;
/**
 * Instead of the while when fix conflict.
 * */
export declare function walkLoop(fn: () => Promise<ConflictFixResult[]>, max?: number): Promise<ConflictFixResult>;
/**
 * Instead of the console.log.
 * @example
 * const l = createLogFunction('EventBody');
 * l`Hello, world`;
 * > Hello, world
 * */
export declare function createLogFunction(prefix: string): (stringArr: TemplateStringsArray, ...values: any[]) => void;
/**
 * Return a new freezed object base on specified object.
 * Like Object.freeze, but it's deep and will not change origin object.
 * */
export declare function deepFreeze<T>(originObject: T): Readonly<T>;
export declare function parseDate(material: any): Date;
export declare function createDraw<T extends Timeline, U extends typeof Timeline>(name: string, timelineConstructor: U): (el: string | HTMLElement, data: any) => Promise<T>;
