import { Extension, ExtensionManager, ExtensionType } from '.';
import Component from '../common/Component';
/**
 * Create element following comp.drawInfo.box for debug.
 * Using this extension, the development can inspect an Short-Night Component by Web Console.
 * */
export default class BoxElementGenerator implements Partial<Extension> {
    ext: ExtensionManager;
    constructor(ext: ExtensionManager);
    type: ExtensionType;
    /**
     * Create a element append to container.
     * The element size equal component.drawInfo.box.
     * */
    onApply(comp: Component): Promise<void>;
    /**
     * Remove element created in onApply.
     * */
    onDestroy(comp: Component): void;
}
