import EventBody from '../../Event/EventBody';
import { ExtensionManager } from '..';
import { Conflict as ComponentConflict } from '.';
import { ConflictFixResult } from '../../types';
declare type Conflict = ComponentConflict<EventBody>;
export default class EventBody2EventBodyMover {
    ext: ExtensionManager;
    constructor(ext: ExtensionManager);
    conflicts: Conflict[];
    /**
     * above EventBody is above, below EventBody is below
     * */
    eventBodyList: EventBody[];
    spaceMap: Map<EventBody, {
        top: number;
        bottom: number;
    }>;
    static avoid({ mover, fixed, direction }: {
        mover: EventBody;
        fixed: EventBody;
        direction: 1 | -1;
    }): Promise<void>;
    static isConflict(eb1: EventBody, eb2: EventBody): boolean;
    fix(): Promise<ConflictFixResult>;
    /**
     * @return {boolean} have fixed one of conflicts?
     * */
    protected tryFixOne(): Promise<ConflictFixResult>;
    protected isPossible(conflict: Conflict): boolean;
    protected fixConflict(conflict: Conflict): Promise<void>;
    protected countConflict(): Promise<void>;
    protected countCast(conflict: Conflict): number;
    /**
     * Count the number how many space needed for fix the conflict by verticalMove
     * */
    protected countNeeded(conflict: Conflict): {
        top: number;
        bottom: number;
    };
    /**
     * Count the number how many space the component can move
     * */
    protected countSpace(): void;
}
export {};
