import { Extension, ExtensionManager } from '..';
import Component from '../../common/Component';
import { ConflictFixResult } from '../../types';
export interface Conflict<T = Component> {
    with: T[];
    self: T;
}
/**
 * Fix the conflict between component and each other by:
 * 1. adjust component using fixers.
 * 2. stretch Axis.
 * */
export default class ConflictFixer implements Partial<Extension> {
    ext: ExtensionManager;
    constructor(ext: ExtensionManager);
    fixers: {
        fix(): Promise<ConflictFixResult>;
    }[];
    protected counter: number;
    onApply(timeline: Component): Promise<void>;
    /**
     * Try fix all conflict by adjust components.
     * */
    fixAll(): Promise<ConflictFixResult>;
}
