"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var definitions_1 = require("../../common/definitions");
var Timeline_1 = __importDefault(require("../../Timeline"));
var functions_1 = require("../../common/functions");
var EventBody2AxisMilestone_1 = __importDefault(require("./EventBody2AxisMilestone"));
var EventAxis2EventAxis_1 = __importDefault(require("./EventAxis2EventAxis"));
var EventBody2EventBodyMover_1 = __importDefault(require("./EventBody2EventBodyMover"));
var EventBody2EventBodyFloater_1 = __importDefault(require("./EventBody2EventBodyFloater"));
/**
 * Fix the conflict between component and each other by:
 * 1. adjust component using fixers.
 * 2. stretch Axis.
 * */
var ConflictFixer = /** @class */ (function () {
    function ConflictFixer(ext) {
        this.ext = ext;
        this.fixers = [
            new EventBody2AxisMilestone_1.default(this.ext),
            new EventAxis2EventAxis_1.default(this.ext),
            new EventBody2EventBodyMover_1.default(this.ext),
            new EventBody2EventBodyFloater_1.default(this.ext),
        ];
        this.counter = 0;
    }
    ConflictFixer.prototype.onApply = function (timeline) {
        return __awaiter(this, void 0, void 0, function () {
            var msg;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!Timeline_1.default.is(timeline))
                            return [2 /*return*/];
                        return [4 /*yield*/, this.fixAll()];
                    case 1:
                        // Conflict is fixed
                        if ((_a.sent()) === "no-conflict" /* NoConflict */) {
                            if (this.counter > 3) {
                                console.warn("[ShortNight]: the conflict fixed by " + this.counter + " times.");
                            }
                            this.counter = 0;
                            return [2 /*return*/];
                        }
                        // Try stretch length of Axis
                        this.counter++;
                        if (this.counter > 10) { // TODO: make configurable
                            msg = "Too many times(" + this.counter + ") of try fix conflict.";
                            if (definitions_1.DEBUG)
                                throw new Error(msg);
                            else
                                console.warn(msg);
                        }
                        return [4 /*yield*/, Promise.resolve().then(function () { return timeline.apply({
                                axisLength: timeline.runtime.axisLength * 1.3,
                            }); })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Try fix all conflict by adjust components.
     * */
    ConflictFixer.prototype.fixAll = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, functions_1.walkLoop(function () { return __awaiter(_this, void 0, void 0, function () {
                            var results, _a, _b, fixer, _c, _d, e_1_1;
                            var e_1, _e;
                            return __generator(this, function (_f) {
                                switch (_f.label) {
                                    case 0:
                                        results = [];
                                        _f.label = 1;
                                    case 1:
                                        _f.trys.push([1, 6, 7, 8]);
                                        _a = __values(this.fixers), _b = _a.next();
                                        _f.label = 2;
                                    case 2:
                                        if (!!_b.done) return [3 /*break*/, 5];
                                        fixer = _b.value;
                                        _d = (_c = results).push;
                                        return [4 /*yield*/, fixer.fix()];
                                    case 3:
                                        _d.apply(_c, [_f.sent()]);
                                        _f.label = 4;
                                    case 4:
                                        _b = _a.next();
                                        return [3 /*break*/, 2];
                                    case 5: return [3 /*break*/, 8];
                                    case 6:
                                        e_1_1 = _f.sent();
                                        e_1 = { error: e_1_1 };
                                        return [3 /*break*/, 8];
                                    case 7:
                                        try {
                                            if (_b && !_b.done && (_e = _a.return)) _e.call(_a);
                                        }
                                        finally { if (e_1) throw e_1.error; }
                                        return [7 /*endfinally*/];
                                    case 8: return [2 /*return*/, results];
                                }
                            });
                        }); })];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    return ConflictFixer;
}());
exports.default = ConflictFixer;
