"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Axis_1 = __importDefault(require("../Axis"));
var functions_1 = require("../common/functions");
var BreakpointAnimation_1 = require("./BreakpointAnimation");
var definitions_1 = require("../common/definitions");
var Timeline_1 = __importDefault(require("../Timeline"));
/**
 * Milestone shouldn't occupy the space of Axis.
 * So we move Event, Scale and Milestone if they upper has any Milestones.
 * */
var PositionCounter = /** @class */ (function () {
    function PositionCounter(ext) {
        this.ext = ext;
        this.pushConfigs = [];
    }
    PositionCounter.prototype.onApply = function (comp) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!Axis_1.default.is(comp)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.adjustAxis(comp)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        if (!Timeline_1.default.is(comp)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.adjustEvent(comp)];
                    case 3: return [2 /*return*/, _a.sent()];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * When a component destroyed, remove a config made by it.
     * */
    PositionCounter.prototype.onDestroy = function (comp) {
        while (true) {
            var index = this.pushConfigs.findIndex(function (config) { return config.component === comp; });
            if (index === -1)
                break;
            else
                this.pushConfigs.splice(index, 1);
        }
    };
    PositionCounter.prototype.adjustAxis = function (axis) {
        return __awaiter(this, void 0, void 0, function () {
            var childComponents, milestones, scales, toRealLength, _a, _b, milestone, e_1_1, axisSpace, milestones_1, milestones_1_1, comp, distance, e_2_1, scales_1, scales_1_1, comp, distance;
            var e_1, _c, e_2, _d, e_3, _e;
            return __generator(this, function (_f) {
                switch (_f.label) {
                    case 0:
                        childComponents = __spread([
                            axis.body
                        ], axis.scales, axis.milestones);
                        milestones = Array.from(axis.milestones)
                            .sort(function (comp1, comp2) { return comp1.drawInfo.alignY - comp2.drawInfo.alignY; });
                        scales = Array.from(axis.scales)
                            .sort(function (comp1, comp2) { return comp1.drawInfo.alignY - comp2.drawInfo.alignY; });
                        // Milestone cannot occupy the space of Axis
                        axis.extraData.realLength =
                            axis.drawInfo.length
                                - axis.milestones.reduce(// Reserved space for Milestone
                                function (h, m) { return h + m.drawInfo.box.height; }, 0);
                        toRealLength = axis.extraData.realLength / axis.drawInfo.length;
                        // Set real Y in milestones and scales
                        axis.milestones.forEach(function (m) { return m.drawInfo.alignY *= toRealLength; });
                        axis.scales.forEach(function (s) { return s.drawInfo.alignY *= toRealLength; });
                        return [4 /*yield*/, Promise.all(__spread(axis.milestones, axis.scales).map(function (c) { return c.apply(); }))];
                    case 1:
                        _f.sent();
                        return [4 /*yield*/, this.ext.breakpoint.block(BreakpointAnimation_1.Breakpoint.PushScalesAndMilestones, {
                                components: childComponents,
                            })];
                    case 2:
                        _f.sent();
                        _f.label = 3;
                    case 3:
                        _f.trys.push([3, 8, 9, 10]);
                        _a = __values(axis.milestones), _b = _a.next();
                        _f.label = 4;
                    case 4:
                        if (!!_b.done) return [3 /*break*/, 7];
                        milestone = _b.value;
                        milestone.drawInfo.alignY += milestone.drawInfo.box.height / 2;
                        return [4 /*yield*/, milestone.apply()];
                    case 5:
                        _f.sent();
                        _f.label = 6;
                    case 6:
                        _b = _a.next();
                        return [3 /*break*/, 4];
                    case 7: return [3 /*break*/, 10];
                    case 8:
                        e_1_1 = _f.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 10];
                    case 9:
                        try {
                            if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 10: 
                    // Set Push-config
                    return [4 /*yield*/, this.updatePushConfigs(axis)];
                    case 11:
                        // Set Push-config
                        _f.sent();
                        axisSpace = axis.body.drawInfo.box.y;
                        return [4 /*yield*/, this.ext.breakpoint.block(BreakpointAnimation_1.Breakpoint.PushScalesAndMilestones, {
                                components: childComponents,
                            })];
                    case 12:
                        _f.sent();
                        _f.label = 13;
                    case 13:
                        _f.trys.push([13, 20, 21, 22]);
                        milestones_1 = __values(milestones), milestones_1_1 = milestones_1.next();
                        _f.label = 14;
                    case 14:
                        if (!!milestones_1_1.done) return [3 /*break*/, 19];
                        comp = milestones_1_1.value;
                        distance = this.countCritical(comp.drawInfo.alignY, comp)
                            + axisSpace;
                        return [4 /*yield*/, Promise.all(milestones.map(function (comp) { return comp.apply(); }))];
                    case 15:
                        _f.sent();
                        return [4 /*yield*/, this.ext.breakpoint.block(BreakpointAnimation_1.Breakpoint.PushScalesAndMilestones, {
                                components: childComponents,
                            })];
                    case 16:
                        _f.sent();
                        comp.drawInfo.alignY += distance;
                        return [4 /*yield*/, this.updatePushConfigs(axis)];
                    case 17:
                        _f.sent();
                        _f.label = 18;
                    case 18:
                        milestones_1_1 = milestones_1.next();
                        return [3 /*break*/, 14];
                    case 19: return [3 /*break*/, 22];
                    case 20:
                        e_2_1 = _f.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 22];
                    case 21:
                        try {
                            if (milestones_1_1 && !milestones_1_1.done && (_d = milestones_1.return)) _d.call(milestones_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 22: return [4 /*yield*/, this.ext.breakpoint.block(BreakpointAnimation_1.Breakpoint.PushScalesAndMilestones, {
                            components: childComponents,
                        })];
                    case 23:
                        _f.sent();
                        try {
                            for (scales_1 = __values(scales), scales_1_1 = scales_1.next(); !scales_1_1.done; scales_1_1 = scales_1.next()) {
                                comp = scales_1_1.value;
                                distance = this.countCritical(comp.drawInfo.alignY, comp)
                                    + axisSpace;
                                comp.drawInfo.alignY += distance;
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (scales_1_1 && !scales_1_1.done && (_e = scales_1.return)) _e.call(scales_1);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                        return [4 /*yield*/, Promise.all(scales.map(function (comp) { return comp.apply(); }))];
                    case 24:
                        _f.sent();
                        return [4 /*yield*/, this.ext.breakpoint.block(BreakpointAnimation_1.Breakpoint.PushScalesAndMilestones, {
                                components: childComponents,
                            })];
                    case 25:
                        _f.sent();
                        return [4 /*yield*/, Promise.all(childComponents.map(function (c) { return c.apply(); }))];
                    case 26:
                        _f.sent();
                        axis.drawInfo.box = functions_1.mergeBox.apply(void 0, __spread(childComponents.map(function (c) { return c.drawInfo.box; })));
                        return [2 /*return*/];
                }
            });
        });
    };
    PositionCounter.prototype.adjustEvent = function (timeline) {
        return __awaiter(this, void 0, void 0, function () {
            var events, axis, toRealLength, events_1, events_1_1, event_1;
            var e_4, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        events = timeline.events;
                        axis = this.ext.components[definitions_1.SN.Axis][0];
                        toRealLength = axis.extraData.realLength / axis.drawInfo.length;
                        return [4 /*yield*/, this.updatePushConfigs(axis)];
                    case 1:
                        _b.sent();
                        try {
                            for (events_1 = __values(events), events_1_1 = events_1.next(); !events_1_1.done; events_1_1 = events_1.next()) {
                                event_1 = events_1_1.value;
                                event_1.drawInfo.target.y *= toRealLength;
                                event_1.drawInfo.target.y += this.countCritical(event_1.drawInfo.target.y, event_1);
                                if (event_1.drawInfo.axisLength) {
                                    event_1.drawInfo.axisLength *= toRealLength;
                                    event_1.drawInfo.axisLength +=
                                        this.countCritical(event_1.drawInfo.target.y)
                                            - this.countCritical(event_1.drawInfo.target.y - event_1.drawInfo.axisLength);
                                }
                                event_1.drawInfo.target.y += axis.body.drawInfo.box.y;
                            }
                        }
                        catch (e_4_1) { e_4 = { error: e_4_1 }; }
                        finally {
                            try {
                                if (events_1_1 && !events_1_1.done && (_a = events_1.return)) _a.call(events_1);
                            }
                            finally { if (e_4) throw e_4.error; }
                        }
                        return [4 /*yield*/, Promise.all(events.map(function (event) { return event.apply(); }))];
                    case 2:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    PositionCounter.prototype.addPushConfig = function (config) {
        this.pushConfigs.push(config);
    };
    PositionCounter.prototype.countCritical = function (num, comp) {
        if (this.pushConfigs.length === 0)
            return 0;
        return this.pushConfigs.reduce(function (result, config) {
            if (comp && comp === config.component)
                return result;
            return num + result > config.critical ? result + config.additional : result;
        }, 0);
    };
    PositionCounter.prototype.updatePushConfigs = function (axis) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.all(axis.milestones.map(function (c) { return c.apply(); }))];
                    case 1:
                        _a.sent();
                        axis.milestones.forEach(function (milestone) {
                            var config = _this.pushConfigs.find(function (config) { return config.component === milestone; });
                            if (config) {
                                config.critical = milestone.drawInfo.box.y;
                                config.additional = milestone.drawInfo.box.height;
                            }
                            else {
                                _this.addPushConfig({
                                    critical: milestone.drawInfo.box.y,
                                    additional: milestone.drawInfo.box.height,
                                    component: milestone,
                                });
                            }
                            _this.pushConfigs.sort(function (c1, c2) { return c1.critical - c2.critical; });
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    return PositionCounter;
}());
exports.default = PositionCounter;
